#include "AssetManager.h"
#include "Log.h"
#define STBI_NO_STDIO
#define STB_IMAGE_IMPLEMENTATION
#include "stb_image.h"

AssetManager* AssetManager::ptr = nullptr;

bool AssetManager::loadTexture(const char* path, Texture* p_texture)
{
    FileBuffer texture_data = {};
    if (!loadFile(path, &texture_data))
        return false;

    int width, height, channels;
    const auto* raw_data = reinterpret_cast<const stbi_uc*>(texture_data.data);
    stbi_uc* data = stbi_load_from_memory(raw_data, static_cast<int>(texture_data.size), &width, &height, &channels, 4);
    if (!data) {
        ALOGE("Failed to parse texture file %s", path);
        releaseFileBuffer(texture_data);
        return false;
    }
    *p_texture = Texture(width, height, data);

    return true;
}
